

#include "colors.inc"   
#include "transforms.inc"    

#include "mossplant1_POV_geom.inc" 
#include "mossplant2_POV_geom.inc" 
#include "mossplant3_POV_geom.inc" 
#include "mossleaf1_POV_geom.inc" 
#include "mossleaf2_POV_geom.inc" 
#include "mossleaf3_POV_geom.inc" 
#include "mossleaf4_POV_geom.inc" 


#declare mossHair1=union { 
object{ mossleaf1  scale <0.75, 1.2, 0.75> rotate <0, 0, 0>  translate <0.5, 0, 0.5> }
object{ mossleaf2  scale <0.75, 1.2, 0.75> rotate <0, 110, 0> translate <-0.5, 0, 0.2>  }
object{ mossleaf3  scale <0.75, 1.2, 0.75> rotate <0, 200, 0> translate <0.5, 0, 0.2>  }
object{ mossleaf4  scale <0.4, 0.9, 0.4> rotate <0, 290, 0> translate <-0.5, 0, -0.5>  }
 
scale 0.02
}            
        
#declare mplant1 = object { mossplant1 scale <0.03, 0.02, 0.03> }
#declare mplant2 = object { mossplant2 scale <0.03, 0.02, 0.03> }
#declare mplant3 = object { mossplant3 scale <0.03, 0.02, 0.03> }
              


#declare mossRand = seed(1245);   

// Macro to return a random number

#macro mr(num)
        rand(mossRand)*num
#end

#macro randmoMossVect(mossPos,v1,v2)
        <mossPos.x+mr(v1.x)-mr(v1.x)+mr(v2.x)-mr(v2.x), mossPos.y+mr(v1.y)-mr(v1.y)+mr(v2.y)-mr(v2.y), mossPos.z+mr(v1.z)-mr(v1.z)+mr(v2.z)-mr(v2.z)>
#end            

#declare MOSS_TYPE_1 = 0;
#declare MOSS_TYPE_2 = 1;       
#declare MOSS_TYPE_3 = 2;


#macro Add_Moss_Hair(mossSurface, sVect, eVect, fallDirection, hairSize, hairStep1, hairStep2, mossType, mossHairTex, plantThreshold)
        
        #declare mossHair=mossHair1;
        
        #local objStartPos = min_extent(mossSurface);
        #local objEndPos = max_extent(mossSurface);    


        #declare v1=sVect;
        #declare v2=eVect;
        #declare v3=v2-v1;     
        
        #if(v3.x != 0)
                #if(v3.y != 0)
                        #if(v3.z != 0)
                                #error "Difference between xyz for vectors cannot be greater than zero!"
                        #end
                #end
        #end              
        
        #if(v3.x !=0)
                #declare sVect=<objStartPos.x, sVect.y, sVect.z>;
                #declare eVect=<objEndPos.x, eVect.y, eVect.z>;
        #end
        #if(v3.y !=0)
                #declare sVect=<sVect.x, objStartPos.y, sVect.z>;
                #declare eVect=<eVect.x, objEndPos.y, eVect.z>;
        #end
        #if(v3.z !=0)
                #declare sVect=<sVect.x, sVect.y, objStartPos.z>;
                #declare eVect=<eVect.x, eVect.y, objEndPos.z>;
        #end

        #declare v1=sVect;
        #declare v2=eVect;
        #declare v3=v2-v1;     
                
        
        #if(v3.x != 0)
                #declare Step1Vect=<v3.x, 0, 0>;
        #else                        
                #declare Step1Vect=<0, v3.y, 0>;
        #end                        
        
        #if(v3.z != 0)
                #declare Step2Vect=<0, 0, v3.z>;
        #else                        
                #declare Step2Vect=<0, v3.y, 0>;
        #end            
        
        #declare Step1Vect=Step1Vect/hairStep1;
        #declare Step2Vect=Step2Vect/hairStep2;
        

        #declare step1=0;

        #declare cCount = 0;   
        #declare firstLine=true;     
        #declare percentDone = -1;
        union
        {
        #while(step1 < hairStep1)
                #declare step2=0;  
                #declare mossPos=sVect+(step1*Step1Vect);

                #if(floor((step1/hairStep1)*100) > percentDone)  
                #declare percentDone=floor((step1/hairStep1)*100);
                #warning concat(concat(concat(str(percentDone, 3, 1), "% Done. "), str(cCount,0,0)), " Hairs.")
                #end      

                #while(step2 < hairStep2)     

                        #local N = <0,0,0>;                                                          
                        
                        #local S = trace(mossSurface, randmoMossVect(mossPos,Step1Vect,Step2Vect), fallDirection, N); 

                        #if(vlength(N) > 0) // hit       
                                //cylinder { <0, 0, 0> <0, hairSize, 0> hairSize/(10+mr(10)) scale 1+mr(1) Reorient_Trans(-fallDirection,N) translate S pigment { Yellow } }       
                                
                                object { mossHair scale <hairSize.x+mr(hairSize.x), hairSize.y+mr(hairSize.y*2), hairSize.z+mr(hairSize.z)>  rotate <0, mr(360), 0> Reorient_Trans(-fallDirection,N) translate S }  
                                #if(mr(1) < plantThreshold)   
                                 #if(mr(1) < 0.333)
                                    object { mplant1 scale <hairSize.x+mr(hairSize.x), hairSize.y+mr(hairSize.y*2), hairSize.z+mr(hairSize.z)>  rotate <0, mr(360), 0> Reorient_Trans(-fallDirection,N) translate S } 
                                 #elseif(mr(1) < 0.333)
                                    object { mplant2 scale <hairSize.x+mr(hairSize.x), hairSize.y+mr(hairSize.y*2), hairSize.z+mr(hairSize.z)>  rotate <0, mr(360), 0> Reorient_Trans(-fallDirection,N) translate S } 
                                 #else
                                    object { mplant3 scale <hairSize.x+mr(hairSize.x), hairSize.y+mr(hairSize.y*2), hairSize.z+mr(hairSize.z)>  rotate <0, mr(360), 0> Reorient_Trans(-fallDirection,N) translate S } 
                                 #end                             
                                #end
                                #declare cCount=cCount+1;
                        #end
                                        
                        #declare mossPos=mossPos+Step2Vect;
                        #declare step2=step2+1;
                #end                                       
                #declare step1=step1+1;
        #end
                
                
                material 
                { 
                        mossHairTex
                }
        }


        #if(cCount = 0)
                #error "Place_Moss Error: no Moss has hit the object try using different direction or start/end pos for moss!"
        #end   
        #warning concat("Total: ", str(cCount,1,0), " moss hairs used")   
        

#end // End Mac                                    






#macro Place_Moss(objectSurface, sVect, eVect, random, fallDirection, clumpSize, clumpScale, clumpStep1, clumpStep2, showHairs, hairSize, hairAmount, mossType, mossHairTex, mossEarthTex, plantThreshold)

        #declare v1=sVect;
        #declare v2=eVect;
        #declare v3=v2-v1;      
        
        #if(v3.x != 0)
                #if(v3.y != 0)
                        #if(v3.z != 0)
                                #error "Difference between xyz for vectors cannot be greater than zero!"
                        #end
                #end
        #end
        
        #if(v3.x != 0)
                #declare Step1Vect=<v3.x, 0, 0>;
        #else                        
                #declare Step1Vect=<0, v3.y, 0>;
        #end                        
        
        #if(v3.z != 0)
                #declare Step2Vect=<0, 0, v3.z>;
        #else                        
                #declare Step2Vect=<0, v3.y, 0>;
        #end            
        
        #declare Step1Vect=Step1Vect/clumpStep1;
        #declare Step2Vect=Step2Vect/clumpStep2;
        

        #declare step1=0;

        #declare cCount = 0;   
        #declare firstLine=true;     
        #declare percentDone = -1;

#declare mossBase = blob {
          threshold 0.6
            

        #while(step1 < clumpStep1)
                #declare step2=0;  
                #declare mossPos=sVect+(step1*Step1Vect);

                #if(floor((step1/clumpStep1)*100) > percentDone)  
                #declare percentDone=floor((step1/clumpStep1)*100);
                #warning concat(concat(concat(str(percentDone, 3, 1), "% Done. "), str(cCount,0,0)), " Clumps.")
                #end      

                #while(step2 < clumpStep2)     

                        #local N = <0,0,0>;                                                          
                        
                        #local S = trace(objectSurface, mossPos, fallDirection, N); 

                        #if(vlength(N) > 0) // hit       
                                #if(random)
                                        #if(mr(1) > random)
                                                sphere { <0, 0, 0>, clumpSize*(0.25+mr(1.5)), 1 scale clumpScale*(0.75+mr(0.5)) Reorient_Trans(fallDirection,N) translate S }       
                                        #end 
                                #else
                                        sphere { <0, 0, 0>, clumpSize*(0.25+mr(1.5)), 1 scale clumpScale*(0.5+mr(0.5)) Reorient_Trans(fallDirection,N) translate S }       
                                #end
                                #declare cCount=cCount+1;
                        #end
                                        
                        #declare mossPos=mossPos+Step2Vect;
                        #declare step2=step2+1;
                #end                                       
                #declare step1=step1+1;
        #end
      


        #if(cCount = 0)
                #error "Place_Moss Error: no Moss has hit the object try using different direction or start/end pos for moss!"
        #end   
        #warning concat("Total: ", str(cCount,1,0), " moss clumps used")   
        
        // place hairs
        
        
        }    
        
        union
        {
                #if(showHairs)                                                                                                                        
                        object { Add_Moss_Hair(mossBase, sVect, eVect, fallDirection, hairSize, clumpStep1*hairAmount, clumpStep2*hairAmount, mossType, mossHairTex, plantThreshold) }
                #end
                object 
                {        
                        mossBase   
                                material  
                                { 
                                        mossEarthTex
                                }
                }                     
                
        }

#end // End Mac                                    

